"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * The Toggle component is basically a fancy checkbox like you have in your iphone.
 * Properties:
 * @param id {string}: the id to be used for htmlFor and maybe QA
 * @param checked {boolean}: sets the state of the toggle to be On or Off
 * @param disabled {boolean}: enables the read-only no-interaction mode
 * @param onChange {function}: an event callback called each time the state is changed
 * @param label {string}: a status label to be shown near toggle
 *
 * Required: [ id, onChange ]
 * Defaults: { checked: false, disabled: false }
 *
 * @return XML(JSX) React pure component
 * **/
function Toggle(_ref) {
	var id = _ref.id,
	    onChange = _ref.onChange,
	    label = _ref.label,
	    children = _ref.children,
	    props = _objectWithoutProperties(_ref, ["id", "onChange", "label", "children"]);

	return _react2.default.createElement(
		"div",
		{ className: "tc-toggle switch checkbox" },
		_react2.default.createElement(
			"label",
			{ htmlFor: id },
			_react2.default.createElement("input", _extends({
				type: "checkbox",
				id: id,
				onChange: onChange
			}, props)),
			_react2.default.createElement(
				"span",
				null,
				label || children
			)
		)
	);
}

Toggle.propTypes = {
	id: _react.PropTypes.string.isRequired,
	label: _react.PropTypes.string,
	onChange: _react.PropTypes.func.isRequired,
	children: _react.PropTypes.node
};

exports.default = Toggle;